TEMPLATE = lib
VERSION = 1.0.0
CONFIG += dll
TARGET = LastFmTools
QT += xml network gui

win32{
    DEFINES += LASTFMTOOLS_EXP
    LIBS += -lshfolder -lshell32
}

macx{
    LIBS += -framework SystemConfiguration -framework CoreServices
}

include( ../../definitions.pro.inc )


## definitions.pro.inc puts libs in a debug subfolder, but don't do that
DESTDIR = $$BIN_DIR


FORMS += \
        confirmdialog.ui 

HEADERS += \
        URLLabel.h \
        browserthread.h \
        draglabel.h \
        http.h \
        imagebutton.h \
        metadata.h \
        usermetadata.h \
        utils.h \
        lastfmtools_common.h \
        winutils.h \
        md5/md5.h \
        confirmdialog.h \
        TrackInfo.h \
        watermarkwidget.h \
        containerutils.h \
        logger.h \
        Settings.h \
        WebService.h \
        WebService/fwd.h \
        WebService/Request.h \
        WebService/GetXspfPlaylistRequest.h \
        WebService/XmlRpc.h \
        last.fm.h \
		LastMessageBox.h \
		StationUrl.h
        
SOURCES += \
        last.fm.cpp \
        browserthread.cpp \
        http.cpp \
        metadata.cpp \
        URLLabel.cpp \
        draglabel.cpp \
        imagebutton.cpp \
        usermetadata.cpp \
        utils.cpp \
        winutils.cpp \
        md5/md5.c \
        confirmdialog.cpp \
        TrackInfo.cpp \
        watermarkwidget.cpp \
        containerutils.cpp \
        logger.cpp \
        Settings.cpp \
        WebService.cpp \
        WebService/Request.cpp \
        WebService/XmlRpc.cpp \
        WebService/ActionRequest.cpp \
        WebService/ArtistMetaDataRequest.cpp \
        WebService/ArtistTagsRequest.cpp \
        WebService/ChangeStationRequest.cpp \
        WebService/DeleteFriendRequest.cpp \
        WebService/FriendsRequest.cpp \
        WebService/Handshake.cpp \
        WebService/NeighboursRequest.cpp \
        WebService/RecentTrackRequest.cpp \
        WebService/ReportRebufferingRequest.cpp \
        WebService/RecommendRequest.cpp \
        WebService/SearchTagsRequest.cpp \
        WebService/SetTagRequest.cpp \
        WebService/SimilarArtistsRequest.cpp \
        WebService/SimilarTagsRequest.cpp \
        WebService/TopTagsRequest.cpp \
        WebService/UserPicturesRequest.cpp \
        WebService/UserTagsRequest.cpp \
        WebService/TrackMetaDataRequest.cpp \
        WebService/TrackToIdRequest.cpp \
        WebService/VerifyUserRequest.cpp \
        WebService/GetXspfPlaylistRequest.cpp \
		LastMessageBox.cpp \
		StationUrl.cpp

